/*
	TinyCAD program for schematic capture
	Copyright 1994/1995/2002,2003 Matt Pyne.

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "stdafx.h"
#include "option.h"
#include "revision.h"
#include "registry.h"
#include "TinyCadView.h"
#include "TinyCad.h"
#include "MainFrm.h"
#include "diag.h"



////// The GetBox dialog //////

BEGIN_MESSAGE_MAP( CDlgGetBox, CDialog )
	ON_COMMAND(GETBOX_FIND, OnFind)
END_MESSAGE_MAP()


void CDlgGetBox::OnOK()
{
  GetDlgItemText( GETBOX_NAME, String.GetBuffer(64), 64 );
  String.ReleaseBuffer();

  EndDialog( IDOK );
}

void CDlgGetBox::OnFind()
{
	GetDlgItemText( GETBOX_NAME, String.GetBuffer(64), 64 );
	String.ReleaseBuffer();

	CDlgGetFindBox theDialog(String,this);

	if (theDialog.DoModal() == IDOK) 
	{
		CString SelectString = theDialog.GetSelectString();
		SelectString = SelectString.Left(SelectString.Find(' '));
		SetDlgItemText( GETBOX_NAME, SelectString );
	}
}

