/*
	TinyCAD program for schematic capture
	Copyright 1994/1995/2002 Matt Pyne.

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __DLGUPDATEBOX_H__
#define __DLGUPDATEBOX_H__

#include "Symbol.h"

// The Update dialog box
class CDlgUpdateBox : public CDialog 
{
	CLibraryStoreSymbol*		NewSymbol;
	void AddSymbolField( CSymbolField &f );

	CEdit m_edit_control;
	CComboBox m_list_control;
	BOOL m_capture;
	int m_index;
	int m_column;

public:

	CDlgUpdateBox(CWnd* pParentWnd = NULL);
	~CDlgUpdateBox();

// Dialog Data
	//{{AFX_DATA(CDlgUpdateBox)
	enum { IDD = IDD_UPDATE };
	CButton	m_Delete;
	CListCtrl	m_list;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgUpdateBox)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	CSymbolField GetSymbolField( int index );
	CLibraryStoreSymbol *GetSymbol() 
	{ 
		return NewSymbol; 
	}

	void SetSymbol(CLibraryStoreSymbol *s) 
	{ 
		NewSymbol = s; 
	}

// Implementation
protected:
	void EndEdit();
	//{{AFX_MSG(CDlgUpdateBox)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnAdd();
	afx_msg void OnDelete();
	afx_msg void OnClickUpdateList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetfocusUpdateList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_MSG
	afx_msg void OnKillfocusEdit();
	afx_msg void OnKillfocusList();
	DECLARE_MESSAGE_MAP()
};


#endif // __DLGUPDATEBOX_H__
