// DragUtils.h: interface for the CDragUtils class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAGUTILS_H__E6C77B92_5C1E_4F7B_8367_6349A36C01D5__INCLUDED_)
#define AFX_DRAGUTILS_H__E6C77B92_5C1E_4F7B_8367_6349A36C01D5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JunctionUtils.h"

class CDrawingObject;
class CTinyCadDoc;

class CDragUtils  
{
protected:
	struct dragWire
	{
		BOOL			m_MoveA;
		BOOL			m_MoveB;
		CDrawingObject* m_Object;

		CDrawingObject* m_Attached_LineA;
		double			m_Distance_AlongA;

		CDrawingObject* m_Attached_LineB;
		double			m_Distance_AlongB;

		BOOL			m_Done_A;
		BOOL			m_Done_B;

		dragWire( CDrawingObject *o, BOOL MoveA = FALSE, BOOL MoveB = FALSE )
		{
			m_Object = o;
			m_MoveA = MoveA;
			m_MoveB = MoveB;
			m_Attached_LineA = NULL;
			m_Distance_AlongA = 0.0;
			m_Attached_LineB = NULL;
			m_Distance_AlongB = 0.0;
			m_Done_A = FALSE;
			m_Done_B = FALSE;
		}

		bool operator<( const dragWire &b ) const
		{
			return m_Object < b.m_Object;
		}
	};

	typedef std::set<dragWire> wireCollection;
	wireCollection	m_draggedWires;


	void AddWiresAtPoint( CPoint p );
	void AddWireToCollection( dragWire n );
	void AddAttachedObjects( CDrawingObject *wire );
	void MoveAttachedObjects( CDrawingObject *wire );
	void DisplayDraggedWires();

	// Our current design that this object manipulates
	CTinyCadDoc	*m_pDesign;					

	// Have we started?
	BOOL m_started;

	// The stored begin data
	CPoint a;
	CPoint b;
	BOOL single_line;	

	void Begin();

	// Our junction utils
	CJunctionUtils	m_j;

public:
	CDragUtils( CTinyCadDoc* pDesign );
	virtual ~CDragUtils();

	void Begin( CPoint a, CPoint b, BOOL single_line = FALSE );
	void Drag( CPoint r );
	void Move( CPoint r );
	void Clear();

	BOOL Started() { return m_started; }
};

#endif // !defined(AFX_DRAGUTILS_H__E6C77B92_5C1E_4F7B_8367_6349A36C01D5__INCLUDED_)
