/*
	TinyCAD program for schematic capture
	Copyright 1994/1995/2002,2003 Matt Pyne.

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



// LineUtils.h: interface for the CLineUtils class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LINEUTILS_H__7B352AE0_AB93_41F9_B5CB_BB14CDCAB472__INCLUDED_)
#define AFX_LINEUTILS_H__7B352AE0_AB93_41F9_B5CB_BB14CDCAB472__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class TransformSnap;
class CTinyCadDoc;

class CLineUtils  
{
protected:
	CPoint a;
	CPoint b;

	int WhichArea(CPoint p,int left,int right,int top,int bottom) const;
	BOOL rIsInside(CPoint p1,CPoint p2,int left,int right,int top,int bottom) const;

public:
	CLineUtils( CPoint ai, CPoint bi );
	virtual ~CLineUtils();

	// Is the line inside or crosses the rectangle given?
	BOOL IsInside(int left,int right,int top,int bottom) const;

	// Determine how far a point lies from this line
	double DistanceFromPoint( CPoint p, CPoint &d ) const;

	// Determine if a point lies on the line
	BOOL IsPointOnLine( CPoint p, double &distance_along ) const;

	// Given a ratio of how far along the line to move,
	// determine the point
	CPoint GetPointOnLine( double distance_along, TransformSnap *snap  ) const;

	// Split this line up into rectangles for
	// display, without redrawing too large an area...
	void SplitForDisplay( CTinyCadDoc *pDesign, BOOL erase, int grow );

	// Get the length of the line
	double GetLength();

	static double	pointOnLineDistance;
};

#endif // !defined(AFX_LINEUTILS_H__7B352AE0_AB93_41F9_B5CB_BB14CDCAB472__INCLUDED_)
